/*
CPS606 Addgn # 2
RationalTest.java - A test application which reads rational numbers and
performs some arithmetic operations. 

Uses Console.java file for reading in input values.

*/

public class RationalTest {

/* 
    Gets the arrary of Rational numbers and finds the sum of the array.
    Returns the sum as a rational number
    param rarr[] Rational array 
    returns rational number
*/
 private static Rational sumArrayRational(Rational rarr[]) {
     Rational r;
     int len;

     len = rarr.length; // length of the array
     r = new Rational(); // declare an instance of a Rational object

     for(int i = 0; i < len; i++ ) {
         r = Rational.sum(r, rarr[i]); // find the sum of the rational
									   // numbers
     }
     return r;
 }

 /*
   Gets the array of Rational numbers and finds the maximum of the values
   in the array. Returns the maximum value
   param rarr[] Rational array
   returns Rational

 */ 
 private static Rational maxArrayElement(Rational rarr[]) {
     Rational r;
     int len;

     len = rarr.length; // finds the array length
     r = new Rational();

     for(int i = 0; i < len; i++ ) {
         if(Rational.compare(r,rarr[i]) < 0 ) { //compare for the bigger number
             r = r;
         }else {
             r = rarr[i]; // swap accordingly
         }
     }
     return r;
 }

 /*
   Execution begins here with the main program.
 */ 

 public static void main(String[] args) {
     int tot,nm,dn;
     Rational r;
     // Reads in the total number of elements in the array
     tot = Console.readInt("Enter the total number of rational numbers");
     Rational rarr[] = new Rational[tot];

     // Read the numerator and denominator for the rational numbers
     // and construct an array of Rational numbers
     for(int i = 0; i < tot; i++ ){
         nm = Console.readInt("Enter numerator ");
         dn = Console.readInt("Enter denominator");
         rarr[i] = new Rational(nm,dn);
     }
     // print the input rational numbers
     System.out.println("\nNumbers entered were ");
     for(int k=0; k < tot; k++ ){
         r = rarr[k];
         if(k == tot-1) {
             System.out.println(r.toString());
             System.out.println("");
         } else {
             System.out.print( r.toString() + " ,");
         }
     }
      
     // find the sum of the array elements
     r = sumArrayRational(rarr); 
     System.out.println("Sum of the elements= " + r.toString() + "\n");

     // find the maximum number of the array 
     r = maxArrayElement(rarr);
     System.out.println("Maximum Rational number in the array =  " + r.toString() + "\n");

     
 }

}

