
package cps606.cu98xqi;

import java.awt.*;
import cps606.cu98xqi.*;

/**
 * BannerPage.java
 *
 * This page displays the applet's banner in the 
 * center of the page. It extends from Canvas and
 * just has one method to draw the banner.
 * 
 * @author xjqiu@npac.syr.edu
 */

public class BannerPage extends Canvas {
 
 Color bgcol = Color.white; // Background color
 Color fgcol = Color.blue;  // Foreground colour
 Font f = new Font("Helvetica",Font.BOLD,16);
 // text that is displayed on the screen
 String text = "Pizza Corner, Old St, Syracuse, NY 13244";

/**
 * Constructor for the page
 */
 public BannerPage() {
     resize(10,20);
 }
  
/**
 * Overridden paint method draws the string message on the
 * screen, called by the browser.
 */
 public void paint(Graphics g) {
     setBackground(Color.blue);
     g.setFont(f);
     g.setColor(Color.white);
     g.drawString(text, 15,16);
     
 }
} // end of class 
