
package cps606.cu98xqi;

import java.awt.*;
import cps606.cu98xqi.*;

/**
 * PizzaApplet.java
 *
 * The main applet class which starts the applet. 
 * It uses a BorderLayout to place components in the
 * applet window and uses other classes to actually 
 * display text.
 *
 * @author xjqiu@npac.syr.edu
 */

public class PizzaApplet extends java.applet.Applet { // class definition

/**
 * The init method of the applet called the first time and it uses
 * a BorderLayout to place the two components on top and bottom.
 * The banner is displayed on top and the form at the bottom.
 */
 public void init() {
     
     setLayout(new BorderLayout()); // use BorderLayout

     BannerPage bp = new BannerPage(); //instantiate a BannerPage component
     OrderForm oForm = new OrderForm(); //instantiate an OrderForm component
 
     add(bp,"North"); // add the banner to the top of the page
     add(oForm,"West"); //add the OrderForm below it 
 }
} // end of Applet class
