/**
 * CityList.java
 * 
 * This class is used for generating the choice list with city names.
 * It extends from Choice and builds a list with four city names each.
 * 
 * @author xjqiu@npac.syr.edu
 *
 */

package gui; // define package for this class

import java.awt.*;

public class CityList extends Choice { //class definition 

// city name elements
private String[] elements = { "BOS", "NYC","SYR","TOR" };

/**
 * Constructor for the class which takes in the default element 
 * to be displayed 
 *
 */

 public CityList(String str) {
     super(); //call the constructor of the super class
     for(int i=0; i < elements.length; i++ ) {
         add(elements[i]); //add elements to the list
     }    
     select(str); //select the string as default
 }

} // end of class definition
